Commit 8214b24d authored by Joshua Garnett's avatar Joshua Garnett Committed by Andrei Mihu
Browse files

Adding Debian Buster Nakama Image. (#389)

parent a2101772
Loading
Loading
Loading
Loading
+0 −0

File moved.

+58 −0
Original line number Diff line number Diff line
## Copyright 2018 The Nakama Authors
##
## Licensed under the Apache License, Version 2.0 (the "License");
## you may not use this file except in compliance with the License.
## You may obtain a copy of the License at
##
## http:##www.apache.org/licenses/LICENSE-2.0
##
## Unless required by applicable law or agreed to in writing, software
## distributed under the License is distributed on an "AS IS" BASIS,
## WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
## See the License for the specific language governing permissions and
## limitations under the License.

# docker build "$PWD" --build-arg commit="$(git rev-parse --short HEAD)" --build-arg version=v2.1.1 -t heroiclabs/nakama:2.1.1
# docker build "$PWD" --build-arg commit="$(git rev-parse --short HEAD)" --build-arg version="v2.1.1-$(git rev-parse --short HEAD)" -t heroiclabs/nakama-prerelease:"2.1.1-$(git rev-parse --short HEAD)"

FROM golang:1.13.0-buster as builder

ARG commit
ARG version

ENV GOOS linux
ENV GOARCH amd64
ENV CGO_ENABLED 1

RUN git config --global advice.detachedHead false && \
    git clone --quiet --no-checkout https://github.com/joshgarnett/nakama.git /go/build/nakama

WORKDIR /go/build/nakama
RUN git checkout --quiet "$commit" && \
    go build -o /go/build-out/nakama -trimpath -mod=vendor -gcflags "-trimpath $PWD" -asmflags "-trimpath $PWD" -ldflags "-s -w -X main.version=$version -X main.commitID=$commit"

FROM debian:buster

MAINTAINER Heroic Labs <support@heroiclabs.com>

ARG version

LABEL version=$version
LABEL variant=nakama
LABEL description="Distributed server for social and realtime games and apps."

RUN mkdir -p /nakama/data/modules && \
    apt-get update && \
    apt-get -y upgrade && \
    apt-get install -y --no-install-recommends ca-certificates curl tini && \
    apt-get clean && \
    rm -rf /var/lib/apt/lists/*

WORKDIR /nakama/
COPY --from=builder "/go/build-out/nakama" /nakama/
EXPOSE 7349 7350 7351

ENTRYPOINT ["/usr/bin/tini", "--", "/nakama/nakama"]

HEALTHCHECK --interval=5m --timeout=3s \
  CMD curl -f http://localhost:7350/ || exit 1

build/build_docker.sh

0 → 100755
+51 −0
Original line number Diff line number Diff line
#!/usr/bin/env bash

# Copyright 2018 The Nakama Authors.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

set -o errexit
set -o pipefail

VERSION="$1"
COMMIT="$2"

if [ -z "${VERSION}" ]; then
 echo "Error: no version entered. Exiting."
 exit 1
fi

if [ -z "${COMMIT}" ]; then
 echo "Error: no commit entered. Exiting."
 exit 1
fi

pushd "$(dirname "$0")"
    docker build . --file ./Dockerfile.alpine --no-cache --build-arg commit="${COMMIT}" \
        --build-arg version="v${VERSION}-${COMMIT}" \
        -t heroiclabs/nakama:"${VERSION}-alpine3.10-${COMMIT}"

    docker build . --file ./Dockerfile.debian --no-cache --build-arg commit="${COMMIT}" \
        --build-arg version="v${VERSION}-${COMMIT}" \
        -t heroiclabs/nakama:"${VERSION}-buster-${COMMIT}"
popd

pushd "$(dirname "$0")"/pluginbuilder
    docker build . --file ./Dockerfile.alpine --no-cache --build-arg commit="${COMMIT}" \
        --build-arg version="v${VERSION}-${COMMIT}" \
        -t heroiclabs/nakama-pluginbuilder:"${VERSION}-alpine3.10-${COMMIT}"

    docker build . --file ./Dockerfile.debian --no-cache --build-arg commit="${COMMIT}" \
        --build-arg version="v${VERSION}-${COMMIT}" \
        -t heroiclabs/nakama-pluginbuilder:"${VERSION}-buster-${COMMIT}"
popd
+35 −0
Original line number Diff line number Diff line
## Copyright 2018 The Nakama Authors
##
## Licensed under the Apache License, Version 2.0 (the "License");
## you may not use this file except in compliance with the License.
## You may obtain a copy of the License at
##
## http:##www.apache.org/licenses/LICENSE-2.0
##
## Unless required by applicable law or agreed to in writing, software
## distributed under the License is distributed on an "AS IS" BASIS,
## WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
## See the License for the specific language governing permissions and
## limitations under the License.

# docker build "$PWD" --file ./Dockerfile.pluginbuilder --build-arg commit="$(git rev-parse --short HEAD)" --build-arg version=v2.1.1 -t heroiclabs/nakama-pluginbuilder:2.1.1
# docker build "$PWD" --file ./Dockerfile.pluginbuilder --build-arg commit="$(git rev-parse --short HEAD)" --build-arg version="v2.1.1-$(git rev-parse --short HEAD)" -t heroiclabs/nakama-prerelease:"2.1.1-$(git rev-parse --short HEAD)"

FROM golang:1.13.0-buster as builder

MAINTAINER Heroic Labs <support@heroiclabs.com>

ARG commit
ARG version

LABEL version=$version
LABEL variant=nakama-pluginbuilder
LABEL description="A support container to build Go code for Nakama server's runtime."

ENV GOOS linux
ENV GOARCH amd64
ENV CGO_ENABLED 1

WORKDIR /builder

ENTRYPOINT ["go"]